## VirtualBox-7.0.26.tar.bz2

=== src/libs/libxml2-2.13.2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

file(STRINGS "configure.ac" CONFIGURE_AC_LINES)
foreach(line ${CONFIGURE_AC_LINES})
    if(line MATCHES [[^m4_define\(\[(MAJOR_VERSION|MINOR_VERSION|MICRO_VERSION)\],[ \t]*([0-9]+)\)$]])
        set(LIBXML_${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
    elseif(line MATCHES "^(LIBXML_MAJOR_VERSION|LIBXML_MINOR_VERSION|LIBXML_MICRO_VERSION)=([0-9]+)$")
        set(${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
    endif()
endforeach()
set(VERSION "${LIBXML_MAJOR_VERSION}.${LIBXML_MINOR_VERSION}.${LIBXML_MICRO_VERSION}")

project(libxml2 VERSION ${VERSION} LANGUAGES C)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckLinkerFlag)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)
include(FindPkgConfig)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
set(LIBXML2_WITH_AUTOMATA ON)
option(LIBXML2_WITH_C14N "Add the Canonicalization support" ON)
option(LIBXML2_WITH_CATALOG "Add the Catalog support" ON)
option(LIBXML2_WITH_DEBUG "Add the debugging module" ON)
set(LIBXML2_WITH_EXPR ON)
option(LIBXML2_WITH_FTP "Add the FTP support" OFF)
option(LIBXML2_WITH_HTML "Add the HTML support" ON)
option(LIBXML2_WITH_HTTP "Add the HTTP support" OFF)
option(LIBXML2_WITH_ICONV "Add ICONV support" ON)
option(LIBXML2_WITH_ICU "Add ICU support" OFF)
option(LIBXML2_WITH_ISO8859X "Add ISO8859X support if no iconv" ON)
option(LIBXML2_WITH_LEGACY "Add deprecated APIs for compatibility" OFF)
option(LIBXML2_WITH_LZMA "Use liblzma" OFF)
option(LIBXML2_WITH_MODULES "Add the dynamic modules support" ON)
option(LIBXML2_WITH_OUTPUT "Add the serialization support" ON)
option(LIBXML2_WITH_PATTERN "Add the xmlPattern selection interface" ON)
option(LIBXML2_WITH_PROGRAMS "Build programs" ON)
option(LIBXML2_WITH_PUSH "Add the PUSH parser interfaces" ON)
option(LIBXML2_WITH_PYTHON "Build Python bindings" ON)
option(LIBXML2_WITH_READER "Add the xmlReader parsing interface" ON)
option(LIBXML2_WITH_REGEXPS "Add Regular Expressions support" ON)
option(LIBXML2_WITH_SAX1 "Add the older SAX1 interface" ON)
option(LIBXML2_WITH_SCHEMAS "Add Relax-NG and Schemas support" ON)
option(LIBXML2_WITH_SCHEMATRON "Add Schematron support" ON)
option(LIBXML2_WITH_TESTS "Build tests" ON)
option(LIBXML2_WITH_THREADS "Add multithread support" ON)
option(LIBXML2_WITH_THREAD_ALLOC "Add per-thread memory" OFF)
option(LIBXML2_WITH_TLS "Enable thread-local storage" OFF)
option(LIBXML2_WITH_TREE "Add the DOM like tree manipulation APIs" ON)
set(LIBXML2_WITH_UNICODE ON)
option(LIBXML2_WITH_VALID "Add the DTD validation support" ON)
option(LIBXML2_WITH_WRITER "Add the xmlWriter saving interface" ON)
option(LIBXML2_WITH_XINCLUDE "Add the XInclude support" ON)
option(LIBXML2_WITH_XPATH "Add the XPATH support" ON)
option(LIBXML2_WITH_XPTR "Add the XPointer support" ON)
option(LIBXML2_WITH_XPTR_LOCS "Add support for XPointer locations" OFF)
option(LIBXML2_WITH_ZLIB "Use libz" OFF)
set(LIBXML2_XMLCONF_WORKING_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE PATH "Working directory for XML Conformance Test Suite")

if(LIBXML2_WITH_PYTHON)
    check_include_files(unistd.h HAVE_UNISTD_H)
    check_symbol_exists(F_GETFL fcntl.h HAVE_F_GETFL)
    find_package(Python COMPONENTS Interpreter Development REQUIRED)
    #set(LIBXML2_PYTHON_INSTALL_DIR ${Python_SITEARCH} CACHE PATH "Python bindings install directory")
    set(LIBXML2_PYTHON_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/python"
        CACHE PATH "Python bindings install directory")
endif()

foreach(VARIABLE IN ITEMS WITH_AUTOMATA WITH_C14N WITH_CATALOG WITH_DEBUG WITH_EXPR WITH_FTP WITH_HTML WITH_HTTP WITH_ICONV WITH_ICU WITH_ISO8859X WITH_LEGACY WITH_LZMA WITH_MODULES WITH_OUTPUT WITH_PATTERN WITH_PUSH WITH_READER WITH_REGEXPS WITH_SAX1 WITH_SCHEMAS WITH_SCHEMATRON WITH_THREADS WITH_THREAD_ALLOC WITH_TREE WITH_UNICODE WITH_VALID WITH_WRITER WITH_XINCLUDE WITH_XPATH WITH_XPTR WITH_XPTR_LOCS WITH_ZLIB)
    if(LIBXML2_${VARIABLE})
        set(${VARIABLE} 1)
    else()
        set(${VARIABLE} 0)
    endif()
endforeach()

set(LIBXML_VERSION ${VERSION})
set(LIBXML_VERSION_EXTRA "")
math(EXPR LIBXML_VERSION_NUMBER "
    ${LIBXML_MAJOR_VERSION} * 10000 +
    ${LIBXML_MINOR_VERSION} * 100 +
    ${LIBXML_MICRO_VERSION}
")

set(MODULE_EXTENSION "${CMAKE_SHARED_LIBRARY_SUFFIX}")

set(PACKAGE "libxml2")
set(PACKAGE_NAME "libxml2")
set(PACKAGE_STRING "libxml2 ${VERSION}")
set(PACKAGE_TARNAME "libxml2")
set(PACKAGE_URL "https://gitlab.gnome.org/GNOME/libxml2")
set(PACKAGE_VERSION ${VERSION})

if(LIBXML2_WITH_ICONV)
    find_package(Iconv REQUIRED)
endif()

if(LIBXML2_WITH_ICU)
    find_package(ICU REQUIRED COMPONENTS data i18n uc)
endif()

if(LIBXML2_WITH_LZMA)
    find_package(LibLZMA REQUIRED)
endif()

if(LIBXML2_WITH_THREADS)
    find_package(Threads REQUIRED)
    set(THREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
    list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
endif()

if(LIBXML2_WITH_ZLIB)
    find_package(ZLIB REQUIRED)
endif()

if (NOT MSVC)
    check_c_source_compiles("
        void __attribute__((destructor))
        f(void) {}
        int main(void) { return 0; }
    " HAVE_ATTRIBUTE_DESTRUCTOR)
    if(HAVE_ATTRIBUTE_DESTRUCTOR)
        set(ATTRIBUTE_DESTRUCTOR "__attribute__((destructor))")
    endif()
    check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
    check_function_exists(class HAVE_CLASS)
    check_include_files(dlfcn.h HAVE_DLFCN_H)
    check_library_exists(dl dlopen "" HAVE_DLOPEN)
    check_include_files(dl.h HAVE_DL_H)
    check_include_files(fcntl.h HAVE_FCNTL_H)
    check_function_exists(fpclass HAVE_FPCLASS)
    check_function_exists(ftime HAVE_FTIME)
    check_function_exists(getentropy HAVE_GETENTROPY)
    check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
    check_library_exists(history append_history "" HAVE_LIBHISTORY)
    check_library_exists(readline readline "" HAVE_LIBREADLINE)
    check_function_exists(mmap HAVE_MMAP)
    check_function_exists(munmap HAVE_MUNMAP)
    check_include_files(netdb.h HAVE_NETDB_H)
    check_include_files(netinet/in.h HAVE_NETINET_IN_H)
    check_include_files(poll.h HAVE_POLL_H)
    check_library_exists(dld shl_load "" HAVE_SHLLOAD)
    check_function_exists(stat HAVE_STAT)
    check_include_files(stdint.h HAVE_STDINT_H)
    check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
    check_include_files(sys/random.h HAVE_SYS_RANDOM_H)
    check_include_files(sys/select.h HAVE_SYS_SELECT_H)
    check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
    check_include_files(sys/stat.h HAVE_SYS_STAT_H)
    check_include_files(sys/timeb.h HAVE_SYS_TIMEB_H)
    check_include_files(sys/time.h HAVE_SYS_TIME_H)
    check_include_files(unistd.h HAVE_UNISTD_H)
    check_c_source_compiles("
        #include <stddef.h>
        #include <sys/socket.h>
        int main() { (void) getsockopt(1, 1, 1, NULL, (socklen_t*) NULL); return 0; }
    " XML_SOCKLEN_T_SOCKLEN_T)
    if(XML_SOCKLEN_T_SOCKLEN_T)
        set(XML_SOCKLEN_T socklen_t)
    else()
        check_c_source_compiles("
            #include <stddef.h>
            #include <sys/socket.h>
            int main() { (void) getsockopt(1, 1, 1, NULL, (size_t*) NULL); return 0; }
        " XML_SOCKLEN_T_SIZE_T)
        if(XML_SOCKLEN_T_SIZE_T)
            set(XML_SOCKLEN_T size_t)
        else()
            check_c_source_compiles("
                #include <stddef.h>
                #include <sys/socket.h>
                int main() { (void) getsockopt (1, 1, 1, NULL, (int*) NULL); return 0; }
            " XML_SOCKLEN_T_INT)
            set(XML_SOCKLEN_T int)
        endif()
    endif()
endif()

if(LIBXML2_WITH_TLS)
    check_c_source_compiles(
        "_Thread_local int v; int main(){return 0;}"
        XML_THREAD_LOCAL_C11
    )
    if (XML_THREAD_LOCAL_C11)
        set(XML_THREAD_LOCAL "_Thread_local")
    else()
        check_c_source_compiles(
            "__thread int v; int main(){return 0;}"
            XML_THREAD_LOCAL_THREAD
        )
        if (XML_THREAD_LOCAL_THREAD)
            set(XML_THREAD_LOCAL "__thread")
        else()
            check_c_source_compiles(
                "__declspec(thread) int v; int main(){return 0;}"
                XML_THREAD_LOCAL_DECLSPEC
            )
            if (XML_THREAD_LOCAL_DECLSPEC)
                set(XML_THREAD_LOCAL "__declspec(thread)")
            endif()
        endif()
    endif()
endif()

set(
    LIBXML2_HDRS
    include/libxml/c14n.h
    include/libxml/catalog.h
    include/libxml/chvalid.h
    include/libxml/debugXML.h
    include/libxml/dict.h
    include/libxml/encoding.h
    include/libxml/entities.h
    include/libxml/globals.h
    include/libxml/hash.h
    include/libxml/HTMLparser.h
    include/libxml/HTMLtree.h
    include/libxml/list.h
    include/libxml/nanoftp.h
    include/libxml/nanohttp.h
    include/libxml/parser.h
    include/libxml/parserInternals.h
    include/libxml/pattern.h
    include/libxml/relaxng.h
    include/libxml/SAX.h
    include/libxml/SAX2.h
    include/libxml/schemasInternals.h
    include/libxml/schematron.h
    include/libxml/threads.h
    include/libxml/tree.h
    include/libxml/uri.h
    include/libxml/valid.h
    include/libxml/xinclude.h
    include/libxml/xlink.h
    include/libxml/xmlIO.h
    include/libxml/xmlautomata.h
    include/libxml/xmlerror.h
    include/libxml/xmlexports.h
    include/libxml/xmlmemory.h
    include/libxml/xmlmodule.h
    include/libxml/xmlreader.h
    include/libxml/xmlregexp.h
    include/libxml/xmlsave.h
    include/libxml/xmlschemas.h
    include/libxml/xmlschemastypes.h
    include/libxml/xmlstring.h
    include/libxml/xmlunicode.h
    include/libxml/xmlwriter.h
    include/libxml/xpath.h
    include/libxml/xpathInternals.h
    include/libxml/xpointer.h
)

set(
    LIBXML2_SRCS
    buf.c
    c14n.c
    catalog.c
    chvalid.c
    debugXML.c
    dict.c
    encoding.c
    entities.c
    error.c
    globals.c
    hash.c
    HTMLparser.c
    HTMLtree.c
    legacy.c
    list.c
    nanoftp.c
    nanohttp.c
    parser.c
    parserInternals.c
    pattern.c
    relaxng.c
    SAX.c
    SAX2.c
    schematron.c
    threads.c
    tree.c
    uri.c
    valid.c
    xinclude.c
    xlink.c
    xmlIO.c
    xmlmemory.c
    xmlmodule.c
    xmlreader.c
    xmlregexp.c
    xmlsave.c
    xmlschemas.c
    xmlschemastypes.c
    xmlstring.c
    xmlunicode.c
    xmlwriter.c
    xpath.c
    xpointer.c
    xzlib.c
)

if(WIN32)
    list(APPEND LIBXML2_SRCS win32/libxml2.rc)
    file(
        WRITE
        ${CMAKE_CURRENT_BINARY_DIR}/rcVersion.h
        "#define LIBXML_MAJOR_VERSION ${LIBXML_MAJOR_VERSION}\n"
        "#define LIBXML_MINOR_VERSION ${LIBXML_MINOR_VERSION}\n"
        "#define LIBXML_MICRO_VERSION ${LIBXML_MICRO_VERSION}\n"
        "#define LIBXML_DOTTED_VERSION \"${VERSION}\"\n"
    )
endif()

add_library(LibXml2 ${LIBXML2_HDRS} ${LIBXML2_SRCS})
add_library(LibXml2::LibXml2 ALIAS LibXml2)

target_compile_definitions(LibXml2 PRIVATE SYSCONFDIR="${CMAKE_INSTALL_FULL_SYSCONFDIR}")

if(LIBXML2_WITH_THREADS)
    if(NOT WIN32)
        check_include_files(pthread.h HAVE_PTHREAD_H)
    endif()
endif()

target_include_directories(
    LibXml2
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}/libxml2>
)

if(LIBXML2_WITH_MODULES)
    if(HAVE_DLOPEN)
        target_link_libraries(LibXml2 PRIVATE dl)
        set(MODULE_PLATFORM_LIBS "-ldl")
    endif()

    if(HAVE_SHLLOAD)
        target_link_libraries(LibXml2 PRIVATE dld)
        set(MODULE_PLATFORM_LIBS "-ldld")
    endif()
endif()

if(UNIX)
    target_link_libraries(LibXml2 PRIVATE m)
    set(LIBM "-lm")
endif()

if(WIN32)
    target_link_libraries(LibXml2 PRIVATE ws2_32)
    set(WINSOCK_LIBS "-lws2_32")
    target_link_libraries(LibXml2 PRIVATE bcrypt)
    set(CRYPTO_LIBS "-lbcrypt")
endif()

if(LIBXML2_WITH_ICONV)

=== src/VBox/HostDrivers/freebsd/Makefile ===
#
# Makefile for the VirtualBox FreeBSD Host Drivers.
#

#
# Copyright (C) 2008-2023 Oracle and/or its affiliates.
#
# This file is part of VirtualBox base platform packages, as
# available from https://www.virtualbox.org.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, in version 3 of the
# License.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <https://www.gnu.org/licenses>.
#
# The contents of this file may alternatively be used under the terms
# of the Common Development and Distribution License Version 1.0
# (CDDL), a copy of it is provided in the "COPYING.CDDL" file included
# in the VirtualBox distribution, in which case the provisions of the
# CDDL are applicable instead of those of the GPL.
#
# You may elect to license modified versions of this file under the
# terms and conditions of either the GPL or the CDDL or both.
#
# SPDX-License-Identifier: GPL-3.0-only OR CDDL-1.0
#

KBUILD_VERBOSE =

all:
	@echo "=== Building 'vboxdrv' module ==="
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxdrv
	@cp vboxdrv/vboxdrv.ko .
	@echo
	@if [ -d vboxnetflt ]; then \
	    if [ -f vboxdrv/Module.symvers ]; then \
	        cp vboxdrv/Module.symvers vboxnetflt; \
	    fi; \
	    echo "=== Building 'vboxnetflt' module ==="; \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetflt; \
	    cp vboxnetflt/vboxnetflt.ko .; \
	    echo; \
	fi
	@if [ -d vboxnetadp ]; then \
	    if [ -f vboxdrv/Module.symvers ]; then \
	        cp vboxdrv/Module.symvers vboxnetadp; \
	    fi; \
	    echo "=== Building 'vboxnetadp' module ==="; \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetadp; \
	    cp vboxnetadp/vboxnetadp.ko .; \
	    echo; \
	fi


install:
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxdrv install
	@if [ -d vboxnetflt ]; then \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetflt install; \
	fi
	@if [ -d vboxnetadp ]; then \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetadp install; \
	fi

clean:
	@$(MAKE) -C vboxdrv clean
	@if [ -d vboxnetflt ]; then \
	    $(MAKE) -C vboxnetflt clean; \
	fi
	@if [ -d vboxnetadp ]; then \
	    $(MAKE) -C vboxnetadp clean; \
	fi
	rm -f vboxdrv.ko vboxnetflt.ko vboxnetadp.ko

load:
	@for module in vboxnetadp vboxnetflt vboxdrv; do \
		if kldstat -n "$$module" >/dev/null; then \
			echo "Removing previously installed $$module module"; \
			/sbin/kldunload $$module; \
		fi; \
	done
	@for module in vboxdrv vboxnetflt vboxnetadp; do \
		if test -f $$module.ko; then \
			echo "Installing $$module module"; \
			/sbin/kldload ./$$module.ko; \
		fi; \
	done

=== src/VBox/HostDrivers/Support/freebsd/Makefile ===
# $Id: Makefile $
## @file
# Makefile for the VirtualBox FreeBSD Host Driver.
#

#
# Copyright (C) 2006-2023 Oracle and/or its affiliates.
#
# This file is part of VirtualBox base platform packages, as
# available from https://www.virtualbox.org.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, in version 3 of the
# License.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <https://www.gnu.org/licenses>.
#
# The contents of this file may alternatively be used under the terms
# of the Common Development and Distribution License Version 1.0
# (CDDL), a copy of it is provided in the "COPYING.CDDL" file included
# in the VirtualBox distribution, in which case the provisions of the
# CDDL are applicable instead of those of the GPL.
#
# You may elect to license modified versions of this file under the
# terms and conditions of either the GPL or the CDDL or both.
#
# SPDX-License-Identifier: GPL-3.0-only OR CDDL-1.0
#

KMOD = vboxdrv

CFLAGS += -DRT_OS_FREEBSD -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DSUPDRV_WITH_RELEASE_LOGGER -DVBOX -DRT_WITH_VBOX -Iinclude -I. -Ir0drv -w -DVBOX_WITH_HARDENING -DVBOX_WITH_64_BITS_GUESTS

.if (${MACHINE_ARCH} == "i386")
 CFLAGS += -DRT_ARCH_X86
.elif (${MACHINE_ARCH} == "amd64")
 CFLAGS += -DRT_ARCH_AMD64
.endif

SRCS = \
	SUPDrv.c \
	SUPDrvGip.c \
	SUPDrvSem.c \
	SUPDrvTracer.c \
	SUPLibAll.c \

# Include needed interface headers so they are created during build
SRCS += \
	device_if.h \
	bus_if.h

.PATH:	${.CURDIR}/freebsd
SRCS += \
	SUPDrv-freebsd.c

.PATH:	${.CURDIR}/alloc
SRCS += \
	heapsimple.c \
	alloc.c

.PATH:	${.CURDIR}/common/err
SRCS += \
	RTErrConvertFromErrno.c \
	RTErrConvertToErrno.c \
	errinfo.c

.PATH:	${.CURDIR}/common/log
SRCS += \
	log.c \
	logellipsis.c \
	logrel.c \
	logrelellipsis.c \
	logcom.c \
	logformat.c \
	RTLogCreateEx.c

.PATH:	${.CURDIR}/common/misc
SRCS += \
	RTAssertMsg1Weak.c \
	RTAssertMsg2.c \
	RTAssertMsg2Add.c \
	RTAssertMsg2AddWeak.c \
	RTAssertMsg2AddWeakV.c \
	RTAssertMsg2Weak.c \
	RTAssertMsg2WeakV.c \
	assert.c \
	handletable.c \
	handletablectx.c \
	once.c \
	term.c \
	thread.c

.PATH:	${.CURDIR}/common/string
SRCS += \
	RTStrCat.c \
	RTStrNCmp.c \
	RTStrNLen.c \
	RTStrCopy.c \
	RTStrCopyEx.c \
	RTStrCopyP.c \
	RTStrEnd.c \
	strformat.c \
	RTStrFormat.c \
	strformatnum.c \
	strformatrt.c \
	strformattype.c \
	strprintf.c \
	strprintf-ellipsis.c \
	strprintf2.c \
	strprintf2-ellipsis.c \
	strtonum.c \
	memchr.c \
	stringalloc.c

.PATH:	${.CURDIR}/common/rand
SRCS += \
	rand.c \
	randadv.c \
	randparkmiller.c

.PATH:	${.CURDIR}/common/path
SRCS += \
	RTPathStripFilename.c

.PATH:	${.CURDIR}/common/checksum
SRCS += \
	crc32.c \
	ipv4.c \
	ipv6.c

.PATH:	${.CURDIR}/common/table
SRCS += \
	avlpv.c

.PATH:	${.CURDIR}/common/time
SRCS += \
	time.c

.PATH:	${.CURDIR}/generic
SRCS += \
	uuid-generic.c \
	RTAssertShouldPanic-generic.c \
	RTLogWriteDebugger-generic.c \
	RTLogWriteStdOut-stub-generic.c \
	RTLogWriteStdErr-stub-generic.c \
	RTLogWriteUser-generic.c \
	RTMpGetArraySize-generic.c \
	RTMpOnPair-generic.c \
	RTRandAdvCreateSystemFaster-generic.c \
	RTRandAdvCreateSystemTruer-generic.c \
	RTSemEventWait-2-ex-generic.c \
	RTSemEventWaitNoResume-2-ex-generic.c \
	RTSemEventMultiWait-2-ex-generic.c \
	RTSemEventMultiWaitNoResume-2-ex-generic.c \
	RTTimerCreate-generic.c \
	rtStrFormatKernelAddress-generic.c \
	errvars-generic.c \
	mppresent-generic.c \
	timer-generic.c

.PATH:	${.CURDIR}/r0drv
SRCS += \
	alloc-r0drv.c \
	alloc-ef-r0drv.c \
	initterm-r0drv.c \
	memobj-r0drv.c \
	powernotification-r0drv.c

.PATH:	${.CURDIR}/r0drv/freebsd
SRCS += \
	assert-r0drv-freebsd.c \
	alloc-r0drv-freebsd.c \
	initterm-r0drv-freebsd.c \
	memobj-r0drv-freebsd.c \
	memuserkernel-r0drv-freebsd.c \
	mp-r0drv-freebsd.c \
	process-r0drv-freebsd.c \
	semevent-r0drv-freebsd.c \
	semeventmulti-r0drv-freebsd.c \
	semfastmutex-r0drv-freebsd.c \
	semmutex-r0drv-freebsd.c \
	spinlock-r0drv-freebsd.c \
	thread-r0drv-freebsd.c \
	thread2-r0drv-freebsd.c \
	time-r0drv-freebsd.c

.PATH:	${.CURDIR}/r0drv/generic
SRCS += \
	semspinmutex-r0drv-generic.c \
	mpnotification-r0drv-generic.c \
	threadctxhooks-r0drv-generic.c \
	RTMpIsCpuWorkPending-r0drv-generic.c

.PATH:	${.CURDIR}/VBox
SRCS += \
	log-vbox.c \
	RTLogWriteVmm-amd64-x86.c

.include <bsd.kmod.mk>

=== debian/changelog ===
virtualbox-ose (7.0.26) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 15 Apr 2025 12:00:00 +0100

virtualbox-ose (7.0.24) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 21 Jan 2025 12:00:00 +0100

virtualbox-ose (7.0.22) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 15 Oct 2024 12:00:00 +0100

virtualbox-ose (7.0.20) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 16 Jul 2024 12:00:00 +0100

virtualbox-ose (7.0.18) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 7 May 2024 12:00:00 +0100

virtualbox-ose (7.0.16) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 16 Apr 2024 12:00:00 +0100

virtualbox-ose (7.0.14) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 16 Jan 2024 12:00:00 +0100

virtualbox-ose (7.0.12) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 17 Oct 2023 12:00:00 +0100

virtualbox-ose (7.0.10) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 18 Jul 2023 12:00:00 +0100

virtualbox-ose (7.0.8) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 18 Apr 2023 12:00:00 +0100

virtualbox-ose (7.0.6) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 17 Jan 2023 12:00:00 +0100

virtualbox-ose (7.0.4) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Fri, 18 Nov 2022 12:00:00 +0100

virtualbox-ose (7.0.2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 20 Oct 2022 12:00:00 +0200

virtualbox-ose (7.0.0) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Mon, 10 Oct 2022 12:00:00 +0200

virtualbox-ose (6.1.4) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 19 Feb 2020 12:00:00 +0200

virtualbox-ose (6.1.2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 14 Jan 2020 12:00:00 +0200

virtualbox-ose (6.1.0) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 10 Dec 2019 12:00:00 +0200

virtualbox-ose (6.1.0~rc1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 22 Nov 2019 12:00:00 +0200

virtualbox-ose (6.1.0~beta2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 24 Oct 2019 12:00:00 +0200

virtualbox-ose (6.1.0~beta1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 12 Sep 2019 12:00:00 +0200

virtualbox-ose (6.0.0) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 18 Dec 2018 12:00:00 +0200

virtualbox-ose (6.0.0~rc1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Mon, 10 Dec 2018 12:00:00 +0200

virtualbox-ose (6.0.0~beta3) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Fri, 30 Nov 2018 12:00:00 +0200

virtualbox-ose (6.0.0~beta2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 11 Nov 2018 12:00:00 +0200

virtualbox-ose (6.0.0~beta1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Mon, 22 Oct 2018 12:00:00 +0200

virtualbox-ose (5.2.2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Wed, 22 Dec 2017 12:00:00 +0200

virtualbox-ose (5.2.0) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 17 Oct 2017 12:00:00 +0200

virtualbox-ose (5.1.30) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Mon, 16 Oct 2017 12:00:00 +0200

virtualbox-ose (5.2.0~rc1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Fri, 29 Sep 2017 15:00:00 +0200

virtualbox-ose (5.2.0~beta3) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Fri, 15 Sep 2017 15:00:00 +0200

virtualbox-ose (5.2.0~beta2) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Tue, 15 Aug 2017 17:00:00 +0200

virtualbox-ose (5.2.0~beta1) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 3 Aug 2017 18:00:00 +0200

virtualbox-ose (5.1.28) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Wed, 13 Sep 2017 12:00:00 +0200

virtualbox-ose (5.1.26) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Thu, 27 Jul 2017 17:00:00 +0200

virtualbox-ose (5.1.24) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Mon, 17 Jul 2017 17:00:00 +0200

virtualbox-ose (5.1.22) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Fri, 28 Apr 2017 16:00:00 +0200

virtualbox-ose (5.1.20) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Wed, 18 Apr 2017 16:00:00 +0200

virtualbox-ose (5.1.18) unstable; urgency=low

  * rebuild Debian package.

 -- Oracle Corporation <info@virtualbox.org>  Wed, 15 Mar 2017 16:00:00 +0100

virtualbox-ose (5.1.16) unstable; urgency=low



=== src/libs/libtpms-0.9.6/debian/changelog ===
libtpms (0.9.6) RELEASED; urgency=high

  - tpm2: Check size of buffer before accessing it (CVE-2023-1017 & -1018)

 -- Stefan Berger <stefanb@linux.ibm.com>  Tue, 28 Feb 2023 09:00:00 -0500

libtpms (0.9.5) RELEASED; urgency=medium

  - tpm2: Do not set RSA_FLAG_NO_BLINDING on RSA keys anymore
  - tpm2: Fix a potential overflow expression (coverity)
  - tpm2: Fix size check in CryptSecretDecrypt

 -- Stefan Berger <stefanb@linux.ibm.com>  Fri, 01 Jul 2022 09:00:00 -0500

libtpms (0.9.4) RELEASED; urgency=medium

  - tpm: #undef printf in case it is #define'd (OSS-Fuzz)
  - tpm2: Check return code of BN_div()
  - tpm2: Initialize variables due to gcc complaint (s390x, false positive)
  - tpm12: Initialize variables due to gcc complaint (s390x, false positive)
  - build-sys: Fix configure script to support _FORTIFY_SOURCE=3

 -- Stefan Berger <stefanb@linux.ibm.com>  Mon, 25 Apr 2022 09:00:00 -0500

libtpms (0.9.3) RELEASED; urgency=medium

  - build-sys: Add probing for -fstack-protector
  - tpm2: Do not call EVP_PKEY_CTX_set0_rsa_oaep_label() for label of size (OSSL 3)

 -- Stefan Berger <stefanb@linux.ibm.com>  Mon, 07 Mar 2022 09:00:00 -0500

libtpms (0.9.2) RELEASED; urgency=medium

  * tpm2: When writing state initialize s_ContextSlotMask if not set

 -- Stefan Berger <stefanb@linux.ibm.com>  Thu, 06 Jan 2022 09:00:00 -0500

libtpms (0.9.1) RELEASED; urgency=medium

  * tpm2: Do not write permanent state if only clock changed

 -- Stefan Berger <stefanb@linux.ibm.com>  Wed, 24 Nov 2021 09:00:00 -0500

libtpms (0.9.0) RELEASED; urgency=medium

  * Stable release

 -- Stefan Berger <stefanb@linux.ibm.com>  Wed, 29 Sep 2021 09:00:00 -0500

libtpms (0.9.0~dev1) UNRELEASED; urgency=medium

  * Developer release 1

 -- Stefan Berger <stefanb@linux.ibm.com>  Wed, 24 Feb 2021 13:48:00 -0500

libtpms (0.8.0) RELEASED; urgency=medium

  * Stable release

 -- Stefan Berger <stefanb@linux.ibm.com>  Wed, 24 Feb 2021 10:55:00 -0500

libtpms (0.8.0~dev1) UNRELEASED; urgency=medium

  * Developer release 1

 -- Stefan Berger <stefanb@linux.ibm.com>  Fri, 19 Jul 2019 13:38:08 -0500

libtpms (0.7.0-1) RELEASED; urgency=medium

  * Stable release

 -- Stefan Berger <stefanb@linux.ibm.com>  Thu, 18 Jul 2019 16:26:00 -0500

libtpms (0.7.0~dev1) UNRELEASED; urgency=medium

  * Stable release

 -- Stefan Berger <stefanb@linux.ibm.com>  Mon, 14 Jan 2019 10:25:08 -0500

libtpms (0.6.0-1) RELEASED; urgency=medium

  * Stable release

 -- Stefan Berger <stefanb@linux.ibm.com>  Wed, 09 Jan 2019 12:28:12 -0500

libtpms (0.6.0-1~dev1) RELEASED; urgency=medium

  * Developer release 1

 -- Stefan Berger <stefanb@linux.vnet.ibm.com>  Mon, 13 Nov 2017 13:03:00 -0500

libtpms (0.6.0) UNRELEASED; urgency=medium

  * Initial Release.

 -- Stefan Berger <stefanb@linux.vnet.ibm.com>  Tue, 12 Jan 2016 11:28:33 -0500

=== debian/control ===
Source: virtualbox-ose
Section: misc
Priority: optional
Maintainer: Oracle Corporation <info@virtualbox.org>
Standards-Version: 3.2.1
Build-Depends: debhelper (>= 5), libz-dev, libssl-dev,
  libsdl1.2-dev, uuid-dev, libxcursor-dev,
  libidl-dev, libpam0g-dev, iasl, xsltproc, linux-headers-generic,
  wine, java2-runtime, lsb-release, g++-multilib [amd64],
  libc6-dev-i386 [amd64], ia32-libs [amd64], libasound-dev,
  libpulse-dev, libxml2-dev, python-dev, gsoap,
  libcap2-dev, libgl1-mesa-dev, libglu1-mesa-dev, libxmu-dev,
  libxext-dev, libcurl-dev, libxrandr-dev, openjdk-6-jdk | sun-java6-jdk,
  libvulkan-dev
XS-Python-Version: >= 2.4

Package: virtualbox-ose
Architecture: i386 amd64
Pre-Depends: debconf (>= 1.1) | debconf-2.0
Depends: debconf (>= 0.5) | debconf-2.0, psmisc, adduser, libvulkan1,
  ${shlibs:Depends},
  ${misc:Depends}
# Do not add python dependencies to the package, because otherwise the user
# will always get a complete python install (and currently it is often a
# python2 install which some users really don't want). Leave the decision
# to users who actually want the VirtualBox API binding for Python.
#  ${python:Depends}
Recommends: ${alsa}, ${pulse}, ${sdlttf}, kmod | kldutils | module-init-tools,
  linux-headers-generic | linux-headers-generic-pae | linux-headers-686-pae | linux-headers-amd64 | linux-headers-2.6-686 | linux-headers-2.6-amd64 | linux-headers,
  linux-image, gcc, make | build-essential | dpkg-dev, binutils,
  pdf-viewer, libgl1
Description: Oracle VM VirtualBox
 VirtualBox is a powerful PC virtualization solution allowing you to run a
 wide range of PC operating systems on your Linux system. This includes
 Windows, Linux, FreeBSD, DOS, OpenBSD and others. VirtualBox comes with a broad
 feature set and excellent performance, making it the premier virtualization
 software solution on the market.
XB-Python-Version: ${python:Versions}

Package: virtualbox-ose-dbg
Architecture: i386 amd64
Depends: virtualbox-ose (= ${binary:Version})
Description: Oracle VM VirtualBox debugging symbols
 VirtualBox is a powerful PC virtualization solution allowing you to run a
 wide range of PC operating systems on your Linux system. This includes
 Windows, Linux, FreeBSD, DOS, OpenBSD and others. VirtualBox comes with a broad
 feature set and excellent performance, making it the premier virtualization
 software solution on the market.
 .
 This package contains debugging symbols.

=== src/VBox/Installer/linux/debian/control ===
Source: virtualbox-7.0
Section: contrib/misc
Priority: optional
Maintainer: Oracle Corporation <info@virtualbox.org>
Standards-Version: 3.2.1
Build-Depends: debhelper (>= 5), libz-dev, libssl-dev,
  libsdl1.2-dev, uuid-dev, libxcursor-dev,
  libidl-dev, libpam0g-dev, iasl, xsltproc, linux-headers-generic,
  wine, java2-runtime, lsb-release, g++-multilib [amd64],
  libc6-dev-i386 [amd64], ia32-libs [amd64], libasound-dev,
  libpulse-dev, libxml2-dev, python-dev, gsoap,
  libcap2-dev, libgl1-mesa-dev, libglu1-mesa-dev, libxmu-dev,
  libxext-dev, libcurl-dev, libxrandr-dev, openjdk-6-jdk | sun-java6-jdk,
  libvulkan-dev
XS-Python-Version: >= 2.4

Package: virtualbox-7.0
Architecture: i386 amd64
Pre-Depends: debconf (>= 1.1) | debconf-2.0
Depends: debconf (>= 0.5) | debconf-2.0, psmisc, adduser, libvulkan1,
  ${shlibs:Depends},
  ${misc:Depends}
# Do not add python dependencies to the package, because otherwise the user
# will always get a complete python install (and currently it is often a
# python2 install which some users really don't want). Leave the decision
# to users who actually want the VirtualBox API binding for Python.
#  ${python:Depends}
Recommends: ${alsa}, ${pulse}, ${sdlttf}, kmod | kldutils | module-init-tools,
  linux-headers-generic | linux-headers-generic-pae | linux-headers-686-pae | linux-headers-amd64 | linux-headers-2.6-686 | linux-headers-2.6-amd64 | linux-headers,
  linux-image, gcc, make | build-essential | dpkg-dev, binutils,
  pdf-viewer, libgl1
Provides: virtualbox
Replaces: virtualbox
Conflicts: virtualbox, virtualbox-dkms, virtualbox-ose, virtualbox-qt, virtualbox-guest-additions-iso
Description: Oracle VM VirtualBox
 VirtualBox is a powerful PC virtualization solution allowing you to run a
 wide range of PC operating systems on your Linux system. This includes
 Windows, Linux, FreeBSD, DOS, OpenBSD and others. VirtualBox comes with a broad
 feature set and excellent performance, making it the premier virtualization
 software solution on the market.
XB-Python-Version: ${python:Versions}

Package: virtualbox-7.0-dbg
Architecture: i386 amd64
Depends: virtualbox-7.0 (= ${binary:Version})
Provides: virtualbox-dbg
Replaces: virtualbox-dbg
Conflicts: virtualbox-dbg, virtualbox-ose-dbg, virtualbox-qt-dbg
Description: Oracle VM VirtualBox debugging symbols
 VirtualBox is a powerful PC virtualization solution allowing you to run a
 wide range of PC operating systems on your Linux system. This includes
 Windows, Linux, FreeBSD, DOS, OpenBSD and others. VirtualBox comes with a broad
 feature set and excellent performance, making it the premier virtualization
 software solution on the market.
 .
 This package contains debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# $Id: rules $
## @file
# VirtualBox rules.
#

#
# Copyright (C) 2006-2023 Oracle and/or its affiliates.
#
# This file is part of VirtualBox base platform packages, as
# available from https://www.virtualbox.org.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, in version 3 of the
# License.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <https://www.gnu.org/licenses>.
#
# SPDX-License-Identifier: GPL-3.0-only
#

#export DH_VERBOSE=1

# possible overrides:
#  OSE=1            force VBOX_OSE
#  NOPARALLEL=1     compile with -j1
#  LINUX=<dir>      compile vboxdrv against Linux found in <dir>
#  VERBOSE=1        verbose build
#  DEBUG=1          debug build
#  NOSUBVER=1       disable generation of the sub-version field (which is
#                   either the subversion rev [if available] or the build date)
#  NODOCS=1         don't build docs, use precompiled UserManual*.pdf and
#                   maybe UserManual*.qch and UserManual*.qhc from $(vboxroot)/prebuild
#  NOMODS=1         don't build any module
#  NOQT=1           don't build the Qt GUI
#  NOSDL=1          don't build VBoxSDL
#  EFI=1            include the EFI binary from prebuild
#  HEADLESS=1       build the headless version
#  VNC=1            build VNC code
#  NOWEBSVC=1       don't build the webservice API
#  STAGEDISO=<path> don't build the VBoxAdditions, use the precompiled .iso
#  PKGDIR=<path>    where to store the final package(s)
#  svn_revision=xxx do not depend on subversion being available, but use this
#                   hard-coded revision number instead
#
# NODOCS will be set if UserManual*.pdf, UserManual*.qch and UserManual*.qhc are
# placed in $(vboxroot)/prebuild.
# STAGEDISO will be set if VBoxGuestAdditions.iso is placed there.
#
# Wine will not be required if STAGEDISO is set.

package  := virtualbox
verpkg   := virtualbox-ose
vboxroot := $(shell while ! test -r configure && ! test "$$PWD" = "/"; do cd ..; done; pwd)
debroot  := $(vboxroot)
instlin  := $(vboxroot)/src/VBox/Installer/linux
pkgdir   := $(if $(PKGDIR),$(PKGDIR),$(shell cd $(vboxroot)/..; pwd))
outdir   := $(if $(PATH_OUT_BASE),$(PATH_OUT_BASE),$(vboxroot)/out)
bldbase  := $(outdir)/debian
builddir := $(bldbase)/builddir
moddir   := $(bldbase)/modules
prefix   := $(bldbase)/$(verpkg)
arch     := $(shell dpkg --print-architecture)
verfile  := $(builddir)/version-generated.mk
ose      := $(if $(OSE),1,$(if $(wildcard $(vboxroot)/src/VBox/RDP/server),,1))

NOMODS   ?= $(ose)
NOQT     ?= $(HEADLESS)
NOSDL    ?= $(HEADLESS)
NOWEBSVC ?=
EFI      ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxEFI32.fd $(vboxroot)/prebuild/VBoxEFI64.fd),1,)
NODOCS   ?= $(if $(wildcard $(addprefix $(vboxroot)/prebuild/,UserManual*.pdf UserManual*.qch UserManual*.qhc)),1,)
STAGEDISO ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxGuestAdditions.iso),$(vboxroot)/prebuild,)
NOWINE   := $(if $(STAGEDISO),1,$(ose))
PYTHON   := $(firstword $(shell which python3) $(shell which python))

DEBPKGFILES := changelog compat control dirs postinst postrm preinst prerm rules templates

ifneq ($(STAGEDISO),)
 ifeq ($(wildcard $(STAGEDISO)/VBoxGuestAdditions.iso),)
  $(error STAGEDISO='$(STAGEDISO)/VBoxGuestAdditions.iso' not found)
 endif
endif

# Replicate debian package buildfiles to $(bldbase)
ifneq ($(shell pwd),$(outdir))
cmd := $(filter-out all Makefile,$(MAKECMDGOALS))
all:
	mkdir -p $(bldbase)
	ln -sf $(addprefix $(debroot)/debian/,$(DEBPKGFILES)) $(bldbase)
	+$(MAKE) -C $(outdir) vboxroot=$(vboxroot) -f debian/rules $(cmd)

Makefile:

$(cmd): all

.PHONY: all $(MAKECMDGOALS)

else
 ifneq ($(wildcard $(verfile)),)
include $(verfile)
ver      := $(VBOX_VERSION_STRING)
archdir  := $(prefix)/opt/VirtualBox-$(ver)
 endif

cfg_flags := $(if $(NOQT),--disable-qt,) \
    $(if $(NOSDL),--disable-vboxsdl,) \
    $(if $(ose),--ose,) $(if $(LINUX),--with-linux=$(LINUX),) \
    $(if $(HEADLESS),--build-headless,) \
    $(if $(DEBUG),--build-debug,) \
    $(if $(NOWINE),,--setup-wine) \
    $(if $(VNC),--enable-vnc,) \
    $(if $(PATH_OUT_BASE),--out-base-dir=$(PATH_OUT_BASE),) \
    --disable-extpack

bld_flags := LOCALCFG=$(debroot)/debian/LocalConfig.kmk \
    PATH_OUT=$(builddir) \
    VBOX_WITHOUT_EXTPACK_PUEL_PACKING=1 \
    VBOX_WITHOUT_EXTPACK_VNC_PACKING=1 \
    VBOX_WITH_VMSVGA3D=1 \
    VBOX_DO_STRIP= \
    VBOX_PATH_PACKAGE_DOCS="/usr/share/doc/$(verpkg)" \
    $(if $(svn_revision),VBOX_SVN_REV=$(svn_revision),) \
    $(if $(NODOCS),VBOX_WITH_DOCS=,) \
    $(if $(VERBOSE),--print-directory KBUILD_VERBOSE=2,--no-print-directory) \
    $(if $(STAGEDISO),VBOX_WITHOUT_ADDITIONS=1,)

configure: $(bldbase)/configure-stamp
$(bldbase)/configure-stamp:
	dh_testdir
	mkdir -p $(bldbase)
	cd $(vboxroot) && ./configure --odir=$(bldbase) $(cfg_flags)
	touch $@

build: $(bldbase)/configure-stamp $(bldbase)/build-stamp
$(bldbase)/build-stamp $(verfile): $(bldbase)/configure-stamp
	dh_testdir
	. $(bldbase)/env.sh && kmk -C $(vboxroot) $(bld_flags) $(if $(NOPARALLEL),-j1,) all
	# Files from prebuild go to (builddir)/bin to be used during the
	# packing stage, overriding what the build did/would produce.
	$(if $(NODOCS),cp $(addprefix $(vboxroot)/prebuild/,UserManual*.pdf UserManual*.qch UserManual*.qhc) $(builddir)/bin,)
	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI32.fd $(builddir)/bin,)
	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI64.fd $(builddir)/bin,)
	mkdir -p $(builddir)/bin/additions
	$(if $(STAGEDISO),cp $(STAGEDISO)/VBoxGuestAdditions.iso $(builddir)/bin/additions,)
	. $(bldbase)/env.sh && kmk -C $(vboxroot) $(bld_flags) \
	    VBOX_NO_LINUX_RUN_INSTALLER=1 \
	    VBOX_LNX_ADD_ARCHIVE.x86=$(builddir)/bin/additions/VBoxGuestAdditions-x86.tar.bz2 \
	    VBOX_LNX_ADD_ARCHIVE.amd64=$(builddir)/bin/additions/VBoxGuestAdditions-amd64.tar.bz2 \
	    VBOX_PATH_ADDITIONS.linux.x86=$(builddir)/bin/additions \
	    VBOX_PATH_ADDITIONS.linux.amd64=$(builddir)/bin/additions \
	    packing
	touch $(bldbase)/build-stamp

# Build modules for every kernel we find in /lib/modules/*
$(bldbase)/modules-stamp: $(bldbase)/build-stamp
	rm -rf $(moddir)
	mkdir $(moddir)
	for d in $(wildcard /lib/modules/*); do \
	    if [ -L $$d/build ]; then \
	        make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
	        make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
	        make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetflt || true) && \
	        make -C $(builddir)/bin/src/vboxnetflt KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetflt/Module.symvers all; \
	        make -C $(builddir)/bin/src/vboxnetadp KERN_VER=$$(basename $$d) clean && \
	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetadp || true) && \
	        make -C $(builddir)/bin/src/vboxnetadp KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetadp/Module.symvers all; \
	        [ -d $(builddir)/bin/src/vboxpci ] && make -C $(builddir)/bin/src/vboxpci KERN_VER=$$(basename $$d) clean && \
	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxpci || true) && \
	        make -C $(builddir)/bin/src/vboxpci KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxpci/Module.symvers all; \
	        true; \
	    fi; \
	done
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean
	rm -rf $(archdir)
	rm -rf $(builddir)
	rm -rf $(moddir)

=== src/VBox/Installer/linux/debian/rules ===
#!/usr/bin/make -f
# $Id: rules $
## @file
# VirtualBox rules.
#

#
# Copyright (C) 2006-2023 Oracle and/or its affiliates.
#
# This file is part of VirtualBox base platform packages, as
# available from https://www.virtualbox.org.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, in version 3 of the
# License.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <https://www.gnu.org/licenses>.
#
# SPDX-License-Identifier: GPL-3.0-only
#

#
# NOTE: if you make changes to this file, please check if the updates should
# be also applied to the publicly visible debian/rules file.
#

#export DH_VERBOSE=1

# possible overrides:
#  OSE=1            force VBOX_OSE
#  NOPARALLEL=1     compile with -j1
#  LINUX=<dir>      compile vboxdrv against Linux found in <dir>
#  VERBOSE=1        verbose build
#  DEBUG=1          debug build
#  NOSUBVER=1       disable generation of the sub-version field (which is
#                   either the subversion rev [if available] or the build date)
#  NODOCS=1         don't build docs, use precompiled UserManual*.pdf and
#                   maybe UserManual*.qch and UserManual*.qhc from $(vboxroot)/prebuild
#  NOMODS=1         don't build any module
#  NOQT=1           don't build the Qt GUI
#  NOSDL=1          don't build VBoxSDL
#  EFI=1            include the EFI binary from prebuild
#  VERSUFFIX=<suffix> set a particular package version suffix (e.g. _customer)
#  HEADLESS=1       build the headless version
#  VNC=1            build VNC code
#  NOWEBSVC=1       don't build the webservice API
#  STAGEDISO=<path> don't build the VBoxAdditions, use the precompiled .iso
#  PKGDIR=<path>    where to store the final package(s)
#  svn_revision=xxx do not depend on subversion being available, but use this
#                   hard-coded revision number instead
#
# NODOCS will be set if UserManual*.pdf, UserManual*.qch and UserManual*.qhc are
# placed in $(vboxroot)/prebuild.
# STAGEDISO will be set if VBoxGuestAdditions.iso is placed there.
#
# Wine will not be required if STAGEDISO is set.

package  := virtualbox
verpkg   := virtualbox-7.0
vboxroot := $(shell while ! test -r configure && ! test "$$PWD" = "/"; do cd ..; done; pwd)
debroot  := $(vboxroot)/src/VBox/Installer/linux
instlin  := $(vboxroot)/src/VBox/Installer/linux
pkgdir   := $(if $(PKGDIR),$(PKGDIR),$(shell cd $(vboxroot)/..; pwd))
outdir   := $(if $(PATH_OUT_BASE),$(PATH_OUT_BASE),$(vboxroot)/out)
bldbase  := $(outdir)/debian
builddir := $(bldbase)/builddir
moddir   := $(bldbase)/modules
prefix   := $(bldbase)/$(verpkg)
arch     := $(shell dpkg --print-architecture)
verfile  := $(builddir)/version-generated.mk
ose      := $(if $(OSE),1,$(if $(wildcard $(vboxroot)/src/VBox/RDP/server),,1))
chrarch  := $(shell if [ `uname -m` = "x86_64" ]; then echo "amd64"; else echo "x86"; fi)
-include $(vboxroot)/SVN_REVISION

NOMODS   ?= $(ose)
NOQT     ?= $(HEADLESS)
NOSDL    ?= $(HEADLESS)
NOWEBSVC ?=
EFI      ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxEFI32.fd $(vboxroot)/prebuild/VBoxEFI64.fd),1,)
NODOCS   ?= $(if $(wildcard $(addprefix $(vboxroot)/prebuild/,UserManual*.pdf UserManual*.qch UserManual*.qhc)),1,)
STAGEDISO ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxGuestAdditions.iso),$(vboxroot)/prebuild,)
NOWINE   := $(if $(STAGEDISO),1,$(ose))
PYTHON   := $(firstword $(shell which python3) $(shell which python))

DEBPKGFILES := changelog compat control dirs postinst postrm preinst prerm rules templates

ifneq ($(STAGEDISO),)
 ifeq ($(wildcard $(STAGEDISO)/VBoxGuestAdditions.iso),)
  $(error STAGEDISO='$(STAGEDISO)/VBoxGuestAdditions.iso' not found)
 endif
endif

# Replicate debian package buildfiles to $(bldbase)
ifneq ($(shell pwd),$(outdir))
cmd := $(filter-out all Makefile,$(MAKECMDGOALS))
all:
	mkdir -p $(bldbase)
	ln -sf $(addprefix $(debroot)/debian/,$(DEBPKGFILES)) $(bldbase)
	+$(MAKE) -C $(outdir) vboxroot=$(vboxroot) -f debian/rules $(cmd)

Makefile:

$(cmd): all

.PHONY: all $(MAKECMDGOALS)

else
 ifneq ($(wildcard $(verfile)),)
include $(verfile)
ver      := $(VBOX_VERSION_STRING)
svnver   := $(if $(NOSUBVER),,$(if $(svn_revision),-$(svn_revision),$(shell if \
		svn info $(vboxroot) > /dev/null 2>&1; then \
		svn info $(vboxroot)|sed -e "s/^Revision: \(.*\)/-\1/;t;d"; else \
		date +"-%Y%m%d"; fi)))
debver   := $(subst _ALPHA,~alpha,$(subst _BETA,~beta,$(subst _RC,~rc,$(subst _OSE,~ose,$(ver)))))$(svnver)$(VERSUFFIX)$(if $(HEADLESS),~headless,)$(if $(DEBUG),~dbg,)
archdir  := $(prefix)/opt/VirtualBox-$(ver)
 endif


ifneq ($(MAKECMDGOALS),clean)
 debrel  := $(if $(shell which lsb_release),_$(shell lsb_release -si)_$(shell lsb_release -sc),unknown)
 debdist  := $(strip $(shell grep $(debrel) $(debroot)/distributions_deb | cut -d'=' -f2))
 ifeq ($(debdist),)
  $(error package distribution not detected (debrel=$(debrel)))
 endif
endif

cfg_flags := $(if $(NOQT),--disable-qt,) \
    $(if $(NOSDL),--disable-vboxsdl,) \
    $(if $(ose),--ose,) $(if $(LINUX),--with-linux=$(LINUX),) \
    $(if $(HEADLESS),--build-headless,) \
    $(if $(DEBUG),--build-debug,) \
    $(if $(NOWINE),,--setup-wine) \
    $(if $(VNC),--enable-vnc,) \
    $(if $(PATH_OUT_BASE),--out-base-dir=$(PATH_OUT_BASE),) \
    --disable-extpack

bld_flags := LOCALCFG=$(debroot)/debian/LocalConfig.kmk \
    PATH_OUT=$(builddir) \
    VBOX_WITHOUT_EXTPACK_PUEL_PACKING=1 \
    VBOX_WITHOUT_EXTPACK_VNC_PACKING=1 \
    VBOX_WITH_VMSVGA3D=1 \
    VBOX_DO_STRIP= \
    VBOX_PATH_PACKAGE_DOCS="/usr/share/doc/$(verpkg)" \
    VBOX_PACKAGE_DIST=$(debdist) \
    $(if $(svn_revision),VBOX_SVN_REV=$(svn_revision),) \
    $(if $(NODOCS),VBOX_WITH_DOCS=,) \
    $(if $(VERBOSE),--print-directory KBUILD_VERBOSE=2,--no-print-directory) \
    $(if $(STAGEDISO),VBOX_WITHOUT_ADDITIONS=1,)

configure: $(bldbase)/configure-stamp
$(bldbase)/configure-stamp:
	dh_testdir
	mkdir -p $(bldbase)
	cd $(vboxroot) && ./configure --odir=$(bldbase) $(cfg_flags)
	touch $@

build: $(bldbase)/configure-stamp $(bldbase)/build-stamp
$(bldbase)/build-stamp $(verfile): $(bldbase)/configure-stamp
	dh_testdir
	. $(bldbase)/env.sh && kmk -C $(vboxroot) $(bld_flags) $(if $(NOPARALLEL),-j1,) all
	# Files from prebuild go to (builddir)/bin to be used during the
	# packing stage, overriding what the build did/would produce.
	$(if $(NODOCS),cp $(addprefix $(vboxroot)/prebuild/,UserManual*.pdf UserManual*.qch UserManual*.qhc) $(builddir)/bin,)
	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI32.fd $(builddir)/bin,)
	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI64.fd $(builddir)/bin,)
	mkdir -p $(builddir)/bin/additions
	$(if $(STAGEDISO),cp $(STAGEDISO)/VBoxGuestAdditions.iso $(builddir)/bin/additions,)
	. $(bldbase)/env.sh && kmk -C $(vboxroot) $(bld_flags) \
	    VBOX_NO_LINUX_RUN_INSTALLER=1 \
	    VBOX_LNX_ADD_ARCHIVE.x86=$(builddir)/bin/additions/VBoxGuestAdditions-x86.tar.bz2 \
	    VBOX_LNX_ADD_ARCHIVE.amd64=$(builddir)/bin/additions/VBoxGuestAdditions-amd64.tar.bz2 \
	    VBOX_PATH_ADDITIONS.linux.x86=$(builddir)/bin/additions \
	    VBOX_PATH_ADDITIONS.linux.amd64=$(builddir)/bin/additions \
	    packing
	touch $(bldbase)/build-stamp

# Build modules for every kernel we find in /lib/modules/*
$(bldbase)/modules-stamp: $(bldbase)/build-stamp
	rm -rf $(moddir)
	mkdir $(moddir)
	for d in $(wildcard /lib/modules/*); do \
	    if [ -L $$d/build ]; then \
	        make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
	        make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
	        make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
